/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * fische-3.1
 * Copyright (C) Marcel Ebmer 2009-2010 <marcel@26elf.at>
 *
 * fische-3.1 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * fische-3.1 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WAVEPAINTER_H
#define WAVEPAINTER_H

#include <cmath>
#include "vector.h"

class SdlScreen;
class VectorField;
class RingBuffer;

class WavePainter {
	private:
		static WavePainter* ms_instance;
		WavePainter ();

	public:
		void change();
		void paint ();
		void beat (double bpm = 0);
		void changeColor();
		void changeShape();

		static WavePainter* instance();

	private:
		void line (Vector& v1, Vector& v2, uint32_t c) {
			line ( (int) (__x0 + v1.x() ), (int) (__y0 + v1.y() ), (int) (__x0 + v2.x() ), (int) (__y0 + v2.y() ), c);
		}
		void line (int, int, int, int, uint32_t);
		int __xCenter, __yCenter;
		int __height;
		int __width;
		int __dir;
		int __x0, __y0;
		SdlScreen* __sdlscreen;
		RingBuffer* __ringbuffer;
		int __shape;
		int __shapes;
		uint32_t __color1;
		uint32_t __color2;
		double __alpha;
		int __state;
		double __inc;
		enum {ROTATING, STEADY};
};

int iround (double);

#endif // WAVEPAINTER_H
